#!/sw/bin/perl

###############################################################################
##                                                                           ##
##    Copyright (c) 1995, 1996, 1997, 1998 by Steffen Beyer.                 ##
##    All rights reserved.                                                   ##
##                                                                           ##
##    Use, modify and redistribute under the same terms as Perl itself.      ##
##                                                                           ##
###############################################################################

# Usage: reply [files]

$maxlen = 73;

if (!@ARGV)
{
    @ARGV = <STDIN>;
    chop(@ARGV);
}

FILE:
foreach $filename (map( glob($_), @ARGV ))
{
    next FILE unless (-f $filename);
    unless (open(INPUT, "<$filename"))
    {
        warn "unable to read '$filename': $!\n";
        next FILE;
    }
    unless (rename($filename,"$filename.bak"))
    {
        warn "unable to rename '$filename' to '$filename.bak': $!\n";
        next FILE;
    }
    unless (open(OUTPUT, ">$filename"))
    {
        warn "unable to write '$filename': $!\n";
        next FILE;
    }
    while (defined($line = <INPUT>))
    {
        $line =~ s/\s+$//;
        while (length($line) > $maxlen)
        {
            $p = $maxlen;
            while (($p > 0) && (substr($line,$p,1) !~ /^\s$/)) { $p--; }
            if ($p > 0)
            {
                $left = substr($line,0,$p);
                $line = substr($line,$p);
                $left =~ s/\s+$//;
                $line =~ s/^\s+//;
            }
            else
            {
                $left = substr($line,0,$maxlen);
                $line = substr($line,$maxlen);
            }
            print OUTPUT "> $left\n";
        }
        print OUTPUT "> $line\n";
    }
    close(INPUT);
    close(OUTPUT);
}

__END__

