#!/sw/bin/perl

# Usage: splitpmpod <file> [<file> ...]

$self = $0;
$self =~ s!^.*[/\\]!!;

FILE:
foreach $file (map( glob($_), @ARGV ))
{
    next FILE unless (-f $file);
    unless (open(ORIG, "<$file"))
    {
        warn "$self: unable to read '$file': $!\n";
        next FILE;
    }
    $base = $file;
    unless ($base =~ s!\.+orig$!!)
    {
        unless (rename($file,"$file.orig"))
        {
            warn "$self: unable to rename '$file' to '$file.orig': $!\n";
            next FILE;
        }
        $file .= ".orig";
    }
    $base =~ s!\.+[^\.]*$!!;
    unless (open(POD, ">$base.pod"))
    {
        warn "$self: unable to write '$base.pod': $!\n";
        close(ORIG);
        next FILE;
    }
    unless (open(PM, ">$base.pm"))
    {
        warn "$self: unable to write '$base.pm': $!\n";
        close(ORIG);
        close(POD);
        next FILE;
    }
    $flag = 0;
    while (defined ($line = <ORIG>))
    {
        if ($line =~ /^=([a-zA-Z]+\d*)\b/)
        {
            if    ($1 eq 'cut') { $flag = 0; }
            elsif ($1 eq 'pod') { $flag = 1; }
            else
            {
                $flag = 1;
                print POD $line;
            }
        }
        else
        {
            if ($flag) { print POD $line; }
            else       { print PM  $line; }
        }
    }
    unless (close(ORIG))
    {
        warn "$self: unable to close '$file': $!\n";
    }
    unless (close(POD))
    {
        warn "$self: unable to close '$base.pod': $!\n";
    }
    unless (close(PM))
    {
        warn "$self: unable to close '$base.pm': $!\n";
    }
}

__END__

